runOn:
  - { minServerVersion: "4.2.0" }

data:
  - {_id: 1, x: 11}
  - {_id: 2, x: 22}

collection_name: &collection_name 'test_replaceone_hint'

tests:
  -
    description: "ReplaceOne with hint string"
    operations:
      -
        object: collection
        name: replaceOne
        arguments:
          filter: &filter { _id: { $gt: 1 } }
          replacement: &replacement {x: 111}
          hint: "_id_"
        result: &result
          matchedCount: 1
          modifiedCount: 1
          upsertedCount: 0
    expectations:
      -
        command_started_event:
          command:
            update: *collection_name
            updates:
              -
                q: *filter
                u: *replacement
                hint: "_id_"
    outcome: &outcome
      collection:
        data:
          - {_id: 1, x: 11 }
          - {_id: 2, x: 111 }
  -
    description: "ReplaceOne with hint document"
    operations:
      -
        object: collection
        name: replaceOne
        arguments: 
          filter: *filter
          replacement: *replacement
          hint: { _id: 1 }
        result: *result
    expectations:
      -
        command_started_event:
          command:
            update: *collection_name
            updates:
              -
                q: *filter
                u: *replacement
                hint: { _id: 1 }
    outcome: *outcome
